function [diff_in_angle, distances4, volume4, X4, dir4, stopID, isnanu, newcenter2] = nextarrow(newcenter2,...
    radius_in_vox_xy,radius_in_vox_z,volSmooth_8bit,FinalPosMat3D,vSnorm,X,voxelsize_xy)

new_centroid = newcenter2;
new_i = (new_centroid(3));

Coord2min = floor(new_centroid(1,1)-radius_in_vox_xy);
Coord2max = ceil(new_centroid(1,1)+radius_in_vox_xy);
Coord1min = floor(new_centroid(1,2)-radius_in_vox_xy);
Coord1max = ceil(new_centroid(1,2)+radius_in_vox_xy);
zmin = floor(new_i-radius_in_vox_z);
zmax = ceil(new_i+radius_in_vox_z);

if Coord2min <= 0
    Coord2min = 1;
end
if Coord2max > size(volSmooth_8bit,2)
    Coord2max = size(volSmooth_8bit,2);
end
if Coord1min <= 0
    Coord1min = 1;
end
if Coord1max > size(volSmooth_8bit,1)
    Coord1max = size(volSmooth_8bit,1);
end
if zmin <= 0
    zmin = 1;
end
if zmax > size(FinalPosMat3D,3)
    zmax = size(FinalPosMat3D,3);
end

probeVolume_Dens = vSnorm(Coord1min:Coord1max,Coord2min:Coord2max,zmin:zmax);
%center = new_centroid;
center = [newcenter2(1)-Coord2min, newcenter2(2)-Coord1min,new_i-zmin];
%center = size(probeVolume_Dens)/2+.5;
%center = [new_centroid(1,1), new_centroid(1,2), new_i];



[columnsInImage, rowsInImage, pagesInImage] = meshgrid(1:size(probeVolume_Dens,1), 1:size(probeVolume_Dens,2), 1:size(probeVolume_Dens,3));
% Next create the circle in the image.
centerX = center(1);
centerY = center(2);
centerZ = center(3);
sphereVoxels = (rowsInImage - centerY).^2./radius_in_vox_xy.^2 ...
    + (columnsInImage - centerX).^2./radius_in_vox_xy.^2 ...
    + (pagesInImage - centerZ).^2./radius_in_vox_z.^2 <= 1;

probeVolume_Dens(~sphereVoxels) = NaN;


Maxi2 = max(max(max((probeVolume_Dens(:,:,:)))));
probeVolume_Dens2 = probeVolume_Dens./Maxi2;
HiInt = probeVolume_Dens2 > 0.98;
L = bwlabeln(HiInt);
stats = regionprops3(L);

centroids = cat(1, stats.Centroid);
volume = cat(1, stats.Volume);

clearvars arrayEnd

arrayStart2 = center;
for k = 1:size(centroids,1)
    a = volume(k,1);
    if a < 2
        volume4(k,1) = NaN;
        distances4(k,1) = NaN;  
        arrayEnd = [arrayStart2(1,1), arrayStart2(1,2), arrayStart2(1,3)];
        X4{k,1} =  [arrayStart2(1,1), arrayStart2(1,2), arrayStart2(1,3); arrayStart2(1,1), arrayStart2(1,2), arrayStart2(1,3)];
    else
        arrayEnd = [centroids(k,1),centroids(k,2),centroids(k,3)];
        X4{k,1} = [arrayEnd(1,1), arrayEnd(1,2), arrayEnd(1,3); arrayStart2(1,1), arrayStart2(1,2), arrayStart2(1,3)];
        distances4(k,1) = pdist(X4{k,1},'euclidean');
        volume4(k,1) = volume(k,1);
    end
end

if size(centroids,1) > 1 
    if sum(isnan(distances4)) == size(centroids,1)
        distances4 = NaN;
        indm = 1;
        X4 =  [arrayStart2(1,1), arrayStart2(1,2), arrayStart2(1,3); arrayStart2(1,1), arrayStart2(1,2), arrayStart2(1,3)];
    else
        mind = (max(distances4));
        indm = distances4 == mind;
        if sum(indm) > 1
           indm = indm(1,1); 
        end
        distances4 = distances4(indm);
        volume4 = volume4(indm);
        X4 = X4{indm};
    end
else
    indm = 1;
    X4 = X4{indm};
end

dir4 = [centroids(indm,1)+Coord2min, centroids(indm,2)+Coord1min, centroids(indm,3)+zmin] - [new_centroid(1,1)+Coord2min, new_centroid(1,2)+Coord1min, new_centroid(1,3)+zmin];

First_arrow = X(1,:)-X(2,:);
Second_arrow = X4(1,:)-X4(2,:);

Xq = [X(2,:);X4(2,:)];
Xq2 = [First_arrow;Second_arrow];

figgi = figure();
set(figgi, 'Visible', 'off')
q = quiver3(Xq(:,1),Xq(:,2),Xq(:,3), Xq2(:,1), Xq2(:,2), Xq2(:,3),...
'AutoScale','off','Color','k','LineWidth',2);
r = atan2(q.VData,q.UData);
degrees = r*180/pi;

clearvars diff_in_angle 

diff_in_angle = min((360) - abs(degrees(1,1) - degrees(2,1)), abs(degrees(1,1) - degrees(2,1)));

close(figgi)


% calculate global displacement
Displacement = round(Second_arrow);
newcenter3 = newcenter2 + Displacement;

% new center becmoes old center
newcenter2 = newcenter3;

%r = atan2(q.VData,q.UData);
%rr = atan2(q.VData,q.WData);
%rrr = atan2(q.UData,q.WData);

%degrees = r*180/pi;
%degreess = rr*180/pi;
%degreesss = rrr*180/pi;

if isnan(distances4)
    stopID = 0;
else
    stopID = 1;
end

if Displacement(1)+Displacement(2) > (1/voxelsize_xy)
    isnanu = NaN;
else
    isnanu = 1;
end

